diff --git a/arch/mips/kernel/vdso.c b/arch/mips/kernel/vdso.c
index f9dbfb1..616fef4 100644
--- a/arch/mips/kernel/vdso.c
+++ b/arch/mips/kernel/vdso.c
@@ -181,6 +181,17 @@ int arch_setup_additional_pages(struct linux_binprm *bprm, int uses_interp)
 	ret = 0;
 
 out:
+	{
+		unsigned long d = data_addr  & 0x00001000LU;
+		unsigned long v = (unsigned long)&vdso_data & 0x00001000LU;
+
+		/* Bit 12 must be identical in user- and kernel-space */
+		printk(KERN_ERR "tgid = %u, pid = %u, comm = %12s: data_addr = "
+			"0x%08lx, &vdso_data = 0x%p => %s\n",
+			current->tgid, current->pid, current->comm, data_addr,
+			&vdso_data, d == v ? "aligned" : "NOT ALIGNED");
+        }
+
 	up_write(&mm->mmap_sem);
 	return ret;
 }
